# coding: utf-8


"""
IGNORE:
    Nutanix Licensing APIs

    licensing desc placeholder  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_licensing_py_client.models.licensing.v4.config.Scope import Scope  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.ValueType import ValueType  # noqa: F401,E501

class AllowanceDetail(object):

    """Model representing allowance details.

    :param feature_id: (:attr:`feature_id`) Indicates feature ID like MAX_NODES, APP_MONITORING.
    :type feature_id: 
     max=100 chars
    
    :param value_type: (:attr:`value_type`) 
    :type value_type: 
    
    
    :param value: (:attr:`value`) Attribute for feature value. For boolean, it will be true/false.For integer it will be any numeric value. True value indicates the feature is available to use.
    :type value: 
     max=25 chars
    
    :param scope: (:attr:`scope`) 
    :type scope: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'feature_id': 'str',
        'value_type': 'licensing.v4.config.ValueType',
        'value': 'str',
        'scope': 'licensing.v4.config.Scope',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'feature_id': 'featureId',
        'value_type': 'valueType',
        'value': 'value',
        'scope': 'scope',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, feature_id=None, value_type=None, value=None, scope=None, *args, **kwargs):  # noqa: E501
        self.__feature_id = None
        self.__value_type = None
        self.__value = None
        self.__scope = None
        self.discriminator = None
        if feature_id is not None:
            self.__feature_id = feature_id
        if value_type is not None:
            self.__value_type = value_type
        if value is not None:
            self.__value = value
        if scope is not None:
            self.__scope = scope
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'licensing.v4.config.AllowanceDetail'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def feature_id(self):
        """
        Indicates feature ID like MAX_NODES, APP_MONITORING.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__feature_id

    @feature_id.setter
    def feature_id(self, feature_id):
        if feature_id is not None and len(feature_id) > 100:
            raise ValueError("Invalid value for `feature_id`, length must be less than or equal to `100`")  # noqa: E501

        self.__feature_id = feature_id

    @property
    def value_type(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.ValueType`
        """  # noqa: E501
        return self.__value_type

    @value_type.setter
    def value_type(self, value_type):

        self.__value_type = value_type

    @property
    def value(self):
        """
        Attribute for feature value. For boolean, it will be true/false.For integer it will be any numeric value. True value indicates the feature is available to use.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__value

    @value.setter
    def value(self, value):
        if value is not None and len(value) > 25:
            raise ValueError("Invalid value for `value`, length must be less than or equal to `25`")  # noqa: E501

        self.__value = value

    @property
    def scope(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.Scope`
        """  # noqa: E501
        return self.__scope

    @scope.setter
    def scope(self, scope):

        self.__scope = scope

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(AllowanceDetail, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllowanceDetail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

