# coding: utf-8


"""
IGNORE:
    Nutanix Licensing APIs

    licensing desc placeholder  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_licensing_py_client.models.licensing.v4.config.BillingPlan import BillingPlan  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.ConsumptionType import ConsumptionType  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.PostPaidCategory import PostPaidCategory  # noqa: F401,E501

class PostPaidConfig(object):

    """Model for capturing postpaid configuration.

    :param id: (:attr:`id`) Attribute for postpaid configuration identifier.
    :type id: 
    
    
    :param category: (:attr:`category`) 
    :type category: 
    
    
    :param is_pulse_required: (:attr:`is_pulse_required`) Indicates whether pulse data collection is required.
    :type is_pulse_required: 
    
    
    :param billing_plan: (:attr:`billing_plan`) 
    :type billing_plan: 
    
    
    :param consumption_type: (:attr:`consumption_type`) 
    :type consumption_type: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'id': 'str',
        'category': 'licensing.v4.config.PostPaidCategory',
        'is_pulse_required': 'bool',
        'billing_plan': 'licensing.v4.config.BillingPlan',
        'consumption_type': 'licensing.v4.config.ConsumptionType',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'id': 'id',
        'category': 'category',
        'is_pulse_required': 'isPulseRequired',
        'billing_plan': 'billingPlan',
        'consumption_type': 'consumptionType',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, id=None, category=None, is_pulse_required=None, billing_plan=None, consumption_type=None, *args, **kwargs):  # noqa: E501
        self.__id = None
        self.__category = None
        self.__is_pulse_required = None
        self.__billing_plan = None
        self.__consumption_type = None
        self.discriminator = None
        if id is not None:
            self.__id = id
        if category is not None:
            self.__category = category
        if is_pulse_required is not None:
            self.__is_pulse_required = is_pulse_required
        if billing_plan is not None:
            self.__billing_plan = billing_plan
        if consumption_type is not None:
            self.__consumption_type = consumption_type
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'licensing.v4.config.PostPaidConfig'

    def _initialize_object_version(self):
        return 'v4.r1'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def id(self):
        """
        Attribute for postpaid configuration identifier.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__id

    @id.setter
    def id(self, id):
        if id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', id):  # noqa: E501
            raise ValueError(r"Invalid value for `id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__id = id

    @property
    def category(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.PostPaidCategory`
        """  # noqa: E501
        return self.__category

    @category.setter
    def category(self, category):

        self.__category = category

    @property
    def is_pulse_required(self):
        """
        Indicates whether pulse data collection is required.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_pulse_required

    @is_pulse_required.setter
    def is_pulse_required(self, is_pulse_required):

        self.__is_pulse_required = is_pulse_required

    @property
    def billing_plan(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.BillingPlan`
        """  # noqa: E501
        return self.__billing_plan

    @billing_plan.setter
    def billing_plan(self, billing_plan):

        self.__billing_plan = billing_plan

    @property
    def consumption_type(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.ConsumptionType`
        """  # noqa: E501
        return self.__consumption_type

    @consumption_type.setter
    def consumption_type(self, consumption_type):

        self.__consumption_type = consumption_type

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(PostPaidConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostPaidConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

